Package org.eclipse.jgit.treewalk.filter

## Class TreeFilter

- java.lang.Object
- - org.eclipse.jgit.treewalk.filter.TreeFilter

Direct Known Subclasses:
  `AndTreeFilter`, `FollowFilter`, `IndexDiffFilter`, `InterIndexDiffFilter`, `NotIgnoredFilter`, `NotTreeFilter`, `OrTreeFilter`, `PathFilter`, `PathSuffixFilter`, `SkipWorkTreeFilter`

    public abstract class TreeFilter
    extends Object

Selects interesting tree entries during walking.

This is an abstract interface. Applications may implement a subclass, or use one of the predefined implementations already available within this package.

Unless specifically noted otherwise a TreeFilter implementation is not thread safe and may not be shared by different TreeWalk instances at the same time. This restriction allows TreeFilter implementations to cache state within their instances during `include(TreeWalk)` if it is beneficial to their implementation. Deep clones created by `clone()` may be used to construct a thread-safe copy of an existing filter.

Path filters:

- Matching pathname: `PathFilter`

Difference filters:

- Only select differences: `ANY_DIFF`.

Boolean modifiers:

- AND: `AndTreeFilter`
- OR: `OrTreeFilter`
- NOT: `NotTreeFilter`

### Field Summary

Fields
`static TreeFilter` `ALL` Selects all tree entries.
`static TreeFilter` `ANY_DIFF` Selects only tree entries which differ between at least 2 trees.

### Constructor Summary

Constructors
`TreeFilter()`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract TreeFilter` `clone()` Clone this tree filter, including its parameters.
`abstract boolean` `include​(TreeWalk walker)` Determine if the current entry is interesting to report.
`TreeFilter` `negate()` Create a new filter that does the opposite of this filter.
`abstract boolean` `shouldBeRecursive()` Does this tree filter require a recursive walk to match everything?
`String` `toString()`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### ALL

    public static final TreeFilter ALL

Selects all tree entries.

#### ANY_DIFF

    public static final TreeFilter ANY_DIFF

Selects only tree entries which differ between at least 2 trees.

This filter also prevents a TreeWalk from recursing into a subtree if all parent trees have the identical subtree at the same path. This dramatically improves walk performance as only the changed subtrees are entered into.

If this filter is applied to a walker with only one tree it behaves like `ALL`, or as though the walker was matching a virtual empty tree against the single tree it was actually given. Applications may wish to treat such a difference as "all names added".

When comparing `WorkingTreeIterator` and `DirCacheIterator` applications should use `IndexDiffFilter`.

### Constructor Detail

#### TreeFilter

    public TreeFilter()

### Method Detail

#### negate

    public TreeFilter negate()

Create a new filter that does the opposite of this filter.

Returns:
  a new filter that includes tree entries this filter rejects.

#### include

    public abstract boolean include​(TreeWalk walker)
                             throws MissingObjectException,
                                    IncorrectObjectTypeException,
                                    IOException

Determine if the current entry is interesting to report.

This method is consulted for subtree entries even if `TreeWalk.isRecursive()` is enabled. The consultation allows the filter to bypass subtree recursion on a case-by-case basis, even when recursion is enabled at the application level.

Parameters:
  `walker` - the walker the filter needs to examine.
Returns:
  true if the current entry should be seen by the application; false to hide the entry.
Throws:
  `MissingObjectException` - an object the filter needs to consult to determine its answer does not exist in the Git repository the walker is operating on. Filtering this current walker entry is impossible without the object.
  `IncorrectObjectTypeException` - an object the filter needed to consult was not of the expected object type. This usually indicates a corrupt repository, as an object link is referencing the wrong type.
  `IOException` - a loose object or pack file could not be read to obtain data necessary for the filter to make its decision.

#### shouldBeRecursive

    public abstract boolean shouldBeRecursive()

Does this tree filter require a recursive walk to match everything?

If this tree filter is matching on full entry path names and its pattern is looking for a '/' then the filter would require a recursive TreeWalk to accurately make its decisions. The walker is not required to enable recursive behavior for any particular filter, this is only a hint.

Returns:
  true if the filter would like to have the walker recurse into subtrees to make sure it matches everything correctly; false if the filter does not require entering subtrees.

#### clone

    public abstract TreeFilter clone()

Clone this tree filter, including its parameters.

This is a deep clone. If this filter embeds objects or other filters it must also clone those, to ensure the instances do not share mutable data.

Overrides:
  `clone` in class `Object`
Returns:
  another copy of this filter, suitable for another thread.

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`